diff --git a/doc/device-tree/ibm,opal.rst b/doc/device-tree/ibm,opal.rst
new file mode 100644
index 0000000..3b90b5b
--- /dev/null
+++ b/doc/device-tree/ibm,opal.rst
@@ -0,0 +1,32 @@
+	ibm,opal {
+		#address-cells = <0x0>;
+		#size-cells = <0x0>;
+		compatible = "ibm,opal-v2", "ibm,opal-v3";
+
+; v2 is maintained for possible compatibility with very, very old kernels
+; it will go away at some point in the future. Detect and rely on ibm,opal-v3
+; ibm,opal-v2 is *NOT* present on POWER9 and above.
+
+		ibm,associativity-reference-points = <0x4 0x3>;
+		ibm,heartbeat-ms = <0x7d0>;
+
+; how often any OPAL call needs to be made to avoid a watchdog timer on BMC
+; from kicking in
+
+		ibm,opal-memcons = <0x0 0x3007a000>;
+
+; location of in memory OPAL console buffer.
+
+		ibm,opal-trace-mask = <0x0 0x3008c3f0>;
+		ibm,opal-traces = <0x0 0x3007b010 0x0 0x10077 0x0 0x3b001010 0x0 0x1000a7 0x0 0x3b103010 0x0 0x1000a7 0x0 0x3b205010 0x0 0x1000a7 0x0 0x3b307010 0x0 0x1000a7 0x0 0x3b409010 0x0 0x1000a7 0x10 0x1801010 0x0 0x1000a7 0x10 0x1903010 0x0 0x1000a7 0x10 0x1a05010 0x0 0x1000a7 0x10 0x1b07010 0x0 0x1000a7 0x10 0x1c09010 0x0 0x1000a7 0x10 0x1d0b010 0x0 0x1000a7 0x10 0x1e0d010 0x0 0x1000a7 0x10 0x1f0f010 0x0 0x1000a7 0x10 0x2011010 0x0 0x1000a7 0x10 0x2113010 0x0 0x1000a7 0x10 0x2215010 0x0 0x1000a7 0x10 0x2317010 0x0 0x1000a7 0x10 0x2419010 0x0 0x1000a7 0x10 0x251b010 0x0 0x1000a7 0x10 0x261d010 0x0 0x1000a7>;
+
+; see docs on tracing
+
+		linux,phandle = <0x10000003>;
+		opal-base-address = <0x0 0x30000000>;
+		opal-entry-address = <0x0 0x300050c0>;
+		opal-interrupts = <0x10 0x11 0x12 0x13 0x14 0x20010 0x20011 0x20012 0x20013 0x20014 0xffe 0xfff 0x17fe 0x17ff 0x2ffe 0x2fff 0x37fe 0x37ff 0x20ffe 0x20fff 0x22ffe 0x22fff 0x237fe 0x237ff>;
+		opal-msg-async-num = <0x8>;
+		opal-msg-size = <0x48>;
+		opal-runtime-size = <0x0 0x9a00000>;
+		phandle = <0x10000003>;
diff --git a/doc/device-tree/ibm,opal.txt b/doc/device-tree/ibm,opal.txt
deleted file mode 100644
index 3b90b5b..0000000
--- a/doc/device-tree/ibm,opal.txt
+++ /dev/null
@@ -1,32 +0,0 @@
-	ibm,opal {
-		#address-cells = <0x0>;
-		#size-cells = <0x0>;
-		compatible = "ibm,opal-v2", "ibm,opal-v3";
-
-; v2 is maintained for possible compatibility with very, very old kernels
-; it will go away at some point in the future. Detect and rely on ibm,opal-v3
-; ibm,opal-v2 is *NOT* present on POWER9 and above.
-
-		ibm,associativity-reference-points = <0x4 0x3>;
-		ibm,heartbeat-ms = <0x7d0>;
-
-; how often any OPAL call needs to be made to avoid a watchdog timer on BMC
-; from kicking in
-
-		ibm,opal-memcons = <0x0 0x3007a000>;
-
-; location of in memory OPAL console buffer.
-
-		ibm,opal-trace-mask = <0x0 0x3008c3f0>;
-		ibm,opal-traces = <0x0 0x3007b010 0x0 0x10077 0x0 0x3b001010 0x0 0x1000a7 0x0 0x3b103010 0x0 0x1000a7 0x0 0x3b205010 0x0 0x1000a7 0x0 0x3b307010 0x0 0x1000a7 0x0 0x3b409010 0x0 0x1000a7 0x10 0x1801010 0x0 0x1000a7 0x10 0x1903010 0x0 0x1000a7 0x10 0x1a05010 0x0 0x1000a7 0x10 0x1b07010 0x0 0x1000a7 0x10 0x1c09010 0x0 0x1000a7 0x10 0x1d0b010 0x0 0x1000a7 0x10 0x1e0d010 0x0 0x1000a7 0x10 0x1f0f010 0x0 0x1000a7 0x10 0x2011010 0x0 0x1000a7 0x10 0x2113010 0x0 0x1000a7 0x10 0x2215010 0x0 0x1000a7 0x10 0x2317010 0x0 0x1000a7 0x10 0x2419010 0x0 0x1000a7 0x10 0x251b010 0x0 0x1000a7 0x10 0x261d010 0x0 0x1000a7>;
-
-; see docs on tracing
-
-		linux,phandle = <0x10000003>;
-		opal-base-address = <0x0 0x30000000>;
-		opal-entry-address = <0x0 0x300050c0>;
-		opal-interrupts = <0x10 0x11 0x12 0x13 0x14 0x20010 0x20011 0x20012 0x20013 0x20014 0xffe 0xfff 0x17fe 0x17ff 0x2ffe 0x2fff 0x37fe 0x37ff 0x20ffe 0x20fff 0x22ffe 0x22fff 0x237fe 0x237ff>;
-		opal-msg-async-num = <0x8>;
-		opal-msg-size = <0x48>;
-		opal-runtime-size = <0x0 0x9a00000>;
-		phandle = <0x10000003>;
diff --git a/doc/device-tree/nvlink.rst b/doc/device-tree/nvlink.rst
new file mode 100644
index 0000000..70e9545
--- /dev/null
+++ b/doc/device-tree/nvlink.rst
@@ -0,0 +1,137 @@
+===========================
+Nvlink Device Tree Bindings
+===========================
+
+See doc/nvlink.txt for general Nvlink information.
+
+NPU bindings:
+
+xscom@3fc0000000000 {
+        npu@8013c00 {
+			reg = <0x8013c00 0x2c>;
+                        compatible = "ibm,power8-npu";
+                        ibm,npu-index = <0x0>;
+                        ibm,npu-links = <0x4>;
+
+; Number of links wired up to this npu.
+
+                        phandle = <0x100002bc>;
+                        linux,phandle = <0x100002bc>;
+
+                        link@0 {
+                                ibm,npu-pbcq = <0x1000000b>;
+
+; phandle to the pbcq which connects to the GPU.
+
+				ibm,npu-phy = <0x80000000 0x8010c3f>;
+
+; SCOM address of the IBM PHY controlling this link.
+
+				compatible = "ibm,npu-link";
+                                ibm,npu-lane-mask = <0xff>;
+
+; Mask specifying which IBM PHY lanes are used for this link.
+
+				phandle = <0x100002bd>;
+                                ibm,npu-link-index = <0x0>;
+
+; Hardware link index. Naples systems contain links at index 0,1,4 & 5.
+; Used to calculate various address offsets.
+
+				linux,phandle = <0x100002bd>;
+                        };
+
+                        link@1 {
+                                ibm,npu-pbcq = <0x1000000b>;
+                                ibm,npu-phy = <0x80000000 0x8010c3f>;
+                                compatible = "ibm,npu-link";
+                                ibm,npu-lane-mask = <0xff00>;
+                                phandle = <0x100002be>;
+                                ibm,npu-link-index = <0x1>;
+                                linux,phandle = <0x100002be>;
+                        };
+
+                        link@4 {
+                                ibm,npu-pbcq = <0x1000000a>;
+                                ibm,npu-phy = <0x80000000 0x8010c7f>;
+                                compatible = "ibm,npu-link";
+                                ibm,npu-lane-mask = <0xff00>;
+                                phandle = <0x100002bf>;
+                                ibm,npu-link-index = <0x4>;
+                                linux,phandle = <0x100002bf>;
+			};
+
+			link@5 {
+                                ibm,npu-pbcq = <0x1000000a>;
+                                ibm,npu-phy = <0x80000000 0x8010c7f>;
+                                compatible = "ibm,npu-link";
+                                ibm,npu-lane-mask = <0xff>;
+                                phandle = <0x100002c0>;
+                                ibm,npu-link-index = <0x5>;
+                                linux,phandle = <0x100002c0>;
+                        };
+	};
+};
+
+Emulated PCI device bindings:
+
+       pciex@3fff000400000 {
+                ibm,npcq = <0x100002bc>;
+
+; phandle to the NPU node. Used to find associated PCI GPU devices.
+
+                compatible = "ibm,power8-npu-pciex", "ibm,ioda2-npu-phb";
+
+		pci@0 {
+                        reg = <0x0 0x0 0x0 0x0 0x0>;
+                        revision-id = <0x0>;
+                        interrupts = <0x1>;
+                        device-id = <0x4ea>;
+                        ibm,pci-config-space-type = <0x1>;
+                        vendor-id = <0x1014>;
+                        ibm,gpu = <0x100002f7>;
+
+; phandle pointing the associated GPU PCI device node
+
+  	  	        phandle = <0x100002fc>;
+                };
+
+                pci@1 {
+                        reg = <0x800 0x0 0x0 0x0 0x0>;
+                        revision-id = <0x0>;
+                        interrupts = <0x1>;
+                        device-id = <0x4ea>;
+                        ibm,pci-config-space-type = <0x1>;
+                        vendor-id = <0x1014>;
+                        ibm,gpu = <0x100002f5>;
+                        phandle = <0x100002fe>;
+                        class-code = <0x60400>;
+                        linux,phandle = <0x100002fe>;
+                };
+
+                pci@0,1 {
+                        reg = <0x100 0x0 0x0 0x0 0x0>;
+                        revision-id = <0x0>;
+                        interrupts = <0x2>;
+                        device-id = <0x4ea>;
+                        ibm,pci-config-space-type = <0x1>;
+                        vendor-id = <0x1014>;
+                        ibm,gpu = <0x100002f7>;
+                        phandle = <0x100002fd>;
+                        class-code = <0x60400>;
+                        linux,phandle = <0x100002fd>;
+                };
+
+                pci@1,1 {
+                       reg = <0x900 0x0 0x0 0x0 0x0>;
+                        revision-id = <0x0>;
+                        interrupts = <0x2>;
+                        device-id = <0x4ea>;
+                        ibm,pci-config-space-type = <0x1>;
+                        vendor-id = <0x1014>;
+                        ibm,gpu = <0x100002f5>;
+                        phandle = <0x100002ff>;
+                        class-code = <0x60400>;
+                        linux,phandle = <0x100002ff>;
+                };
+        };
diff --git a/doc/device-tree/nvlink.txt b/doc/device-tree/nvlink.txt
deleted file mode 100644
index 70e9545..0000000
--- a/doc/device-tree/nvlink.txt
+++ /dev/null
@@ -1,137 +0,0 @@
-===========================
-Nvlink Device Tree Bindings
-===========================
-
-See doc/nvlink.txt for general Nvlink information.
-
-NPU bindings:
-
-xscom@3fc0000000000 {
-        npu@8013c00 {
-			reg = <0x8013c00 0x2c>;
-                        compatible = "ibm,power8-npu";
-                        ibm,npu-index = <0x0>;
-                        ibm,npu-links = <0x4>;
-
-; Number of links wired up to this npu.
-
-                        phandle = <0x100002bc>;
-                        linux,phandle = <0x100002bc>;
-
-                        link@0 {
-                                ibm,npu-pbcq = <0x1000000b>;
-
-; phandle to the pbcq which connects to the GPU.
-
-				ibm,npu-phy = <0x80000000 0x8010c3f>;
-
-; SCOM address of the IBM PHY controlling this link.
-
-				compatible = "ibm,npu-link";
-                                ibm,npu-lane-mask = <0xff>;
-
-; Mask specifying which IBM PHY lanes are used for this link.
-
-				phandle = <0x100002bd>;
-                                ibm,npu-link-index = <0x0>;
-
-; Hardware link index. Naples systems contain links at index 0,1,4 & 5.
-; Used to calculate various address offsets.
-
-				linux,phandle = <0x100002bd>;
-                        };
-
-                        link@1 {
-                                ibm,npu-pbcq = <0x1000000b>;
-                                ibm,npu-phy = <0x80000000 0x8010c3f>;
-                                compatible = "ibm,npu-link";
-                                ibm,npu-lane-mask = <0xff00>;
-                                phandle = <0x100002be>;
-                                ibm,npu-link-index = <0x1>;
-                                linux,phandle = <0x100002be>;
-                        };
-
-                        link@4 {
-                                ibm,npu-pbcq = <0x1000000a>;
-                                ibm,npu-phy = <0x80000000 0x8010c7f>;
-                                compatible = "ibm,npu-link";
-                                ibm,npu-lane-mask = <0xff00>;
-                                phandle = <0x100002bf>;
-                                ibm,npu-link-index = <0x4>;
-                                linux,phandle = <0x100002bf>;
-			};
-
-			link@5 {
-                                ibm,npu-pbcq = <0x1000000a>;
-                                ibm,npu-phy = <0x80000000 0x8010c7f>;
-                                compatible = "ibm,npu-link";
-                                ibm,npu-lane-mask = <0xff>;
-                                phandle = <0x100002c0>;
-                                ibm,npu-link-index = <0x5>;
-                                linux,phandle = <0x100002c0>;
-                        };
-	};
-};
-
-Emulated PCI device bindings:
-
-       pciex@3fff000400000 {
-                ibm,npcq = <0x100002bc>;
-
-; phandle to the NPU node. Used to find associated PCI GPU devices.
-
-                compatible = "ibm,power8-npu-pciex", "ibm,ioda2-npu-phb";
-
-		pci@0 {
-                        reg = <0x0 0x0 0x0 0x0 0x0>;
-                        revision-id = <0x0>;
-                        interrupts = <0x1>;
-                        device-id = <0x4ea>;
-                        ibm,pci-config-space-type = <0x1>;
-                        vendor-id = <0x1014>;
-                        ibm,gpu = <0x100002f7>;
-
-; phandle pointing the associated GPU PCI device node
-
-  	  	        phandle = <0x100002fc>;
-                };
-
-                pci@1 {
-                        reg = <0x800 0x0 0x0 0x0 0x0>;
-                        revision-id = <0x0>;
-                        interrupts = <0x1>;
-                        device-id = <0x4ea>;
-                        ibm,pci-config-space-type = <0x1>;
-                        vendor-id = <0x1014>;
-                        ibm,gpu = <0x100002f5>;
-                        phandle = <0x100002fe>;
-                        class-code = <0x60400>;
-                        linux,phandle = <0x100002fe>;
-                };
-
-                pci@0,1 {
-                        reg = <0x100 0x0 0x0 0x0 0x0>;
-                        revision-id = <0x0>;
-                        interrupts = <0x2>;
-                        device-id = <0x4ea>;
-                        ibm,pci-config-space-type = <0x1>;
-                        vendor-id = <0x1014>;
-                        ibm,gpu = <0x100002f7>;
-                        phandle = <0x100002fd>;
-                        class-code = <0x60400>;
-                        linux,phandle = <0x100002fd>;
-                };
-
-                pci@1,1 {
-                       reg = <0x900 0x0 0x0 0x0 0x0>;
-                        revision-id = <0x0>;
-                        interrupts = <0x2>;
-                        device-id = <0x4ea>;
-                        ibm,pci-config-space-type = <0x1>;
-                        vendor-id = <0x1014>;
-                        ibm,gpu = <0x100002f5>;
-                        phandle = <0x100002ff>;
-                        class-code = <0x60400>;
-                        linux,phandle = <0x100002ff>;
-                };
-        };
diff --git a/doc/device-tree/nx.rst b/doc/device-tree/nx.rst
new file mode 100644
index 0000000..84c97ac
--- /dev/null
+++ b/doc/device-tree/nx.rst
@@ -0,0 +1,45 @@
+Nest (NX) Accelerator Coprocessor
+---------------------------------
+
+The NX coprocessor is present in P7+ or later processors.  Each NX node
+represents a unique NX coprocessor.  The nodes are located under an
+xscom node, as:
+
+/xscom@<xscom_addr>/nx@<nx_addr>
+
+With unique xscom and nx addresses.  Their compatible node contains
+"ibm,power-nx".
+
+
+NX 842 Coprocessor
+------------------
+
+This is the memory compression coprocessor, which uses the IBM proprietary
+842 compression algorithm and format.  Each nx node contains an 842 engine.
+
+ibm,842-coprocessor-type	: CT value common to all 842 coprocessors
+ibm,842-coprocessor-instance	: CI value unique to all 842 coprocessors
+
+Access to the coprocessor requires using the ICSWX instruction, which uses
+a specific format including a Coprocessor Type (CT) and Coprocessor Instance
+(CI) value to address each request to the right coprocessor.  The driver should
+use the CT and CI values for a particular node to communicate with it.  For
+all 842 coprocessors in the system, the CT value will (should) be the same,
+while each will have a different CI value.  The driver can use CI 0 to allow
+the hardware to automatically select which coprocessor instance to use.
+
+
+NX RNG Coprocessor
+------------------
+
+This is the Random Number Generator (RNG) coprocessor, which is a part
+of each NX coprocessor.  Each node represents a unique RNG coprocessor.
+Its nodes are not under the main nx node, they are located at:
+
+/hwrng@<addr>		: RNG at address <addr>
+ibm,chip-id		: chip id where the RNG is
+reg			: address of the register to read from
+
+Each read from the RNG register will provide a new random number.
+
+
diff --git a/doc/device-tree/nx.txt b/doc/device-tree/nx.txt
deleted file mode 100644
index 84c97ac..0000000
--- a/doc/device-tree/nx.txt
+++ /dev/null
@@ -1,45 +0,0 @@
-Nest (NX) Accelerator Coprocessor
----------------------------------
-
-The NX coprocessor is present in P7+ or later processors.  Each NX node
-represents a unique NX coprocessor.  The nodes are located under an
-xscom node, as:
-
-/xscom@<xscom_addr>/nx@<nx_addr>
-
-With unique xscom and nx addresses.  Their compatible node contains
-"ibm,power-nx".
-
-
-NX 842 Coprocessor
-------------------
-
-This is the memory compression coprocessor, which uses the IBM proprietary
-842 compression algorithm and format.  Each nx node contains an 842 engine.
-
-ibm,842-coprocessor-type	: CT value common to all 842 coprocessors
-ibm,842-coprocessor-instance	: CI value unique to all 842 coprocessors
-
-Access to the coprocessor requires using the ICSWX instruction, which uses
-a specific format including a Coprocessor Type (CT) and Coprocessor Instance
-(CI) value to address each request to the right coprocessor.  The driver should
-use the CT and CI values for a particular node to communicate with it.  For
-all 842 coprocessors in the system, the CT value will (should) be the same,
-while each will have a different CI value.  The driver can use CI 0 to allow
-the hardware to automatically select which coprocessor instance to use.
-
-
-NX RNG Coprocessor
-------------------
-
-This is the Random Number Generator (RNG) coprocessor, which is a part
-of each NX coprocessor.  Each node represents a unique RNG coprocessor.
-Its nodes are not under the main nx node, they are located at:
-
-/hwrng@<addr>		: RNG at address <addr>
-ibm,chip-id		: chip id where the RNG is
-reg			: address of the register to read from
-
-Each read from the RNG register will provide a new random number.
-
-
diff --git a/doc/device-tree/reserved-memory.rst b/doc/device-tree/reserved-memory.rst
new file mode 100644
index 0000000..ff0d6a4
--- /dev/null
+++ b/doc/device-tree/reserved-memory.rst
@@ -0,0 +1,30 @@
+reserved-memory device tree nodes
+
+OPAL exposes reserved memory through a top-level reserved-memory node,
+containing subnodes that represent each reserved memory region.
+
+This follows the Linux specification for the /reserved-memory node,
+described in the kernel source tree, in:
+
+  Documentation/devicetree/bindings/reserved-memory/reserved-memory.txt
+
+The top-level /reserved-memory node contains:
+
+  #size-cells = <2>
+  #address-cells = <2>
+   - addresses and sizes are all 64-bits
+
+  ranges;
+   - the empty ranges node indicates no translation of physical
+     addresses in the subnodes.
+
+The sub-nodes under the /reserved-memory node contain:
+
+ reg = <address size>
+  - the address and size of the reserved memory region. The address
+    and size values are two cells each, as signified by the top-level
+    #{address,size}-cells
+
+ ibm,prd-label = "string"
+  - a string token for use by the prd system. Specific ranges may be
+    used by prd - those will be referenced by this label.
diff --git a/doc/device-tree/reserved-memory.txt b/doc/device-tree/reserved-memory.txt
deleted file mode 100644
index ff0d6a4..0000000
--- a/doc/device-tree/reserved-memory.txt
+++ /dev/null
@@ -1,30 +0,0 @@
-reserved-memory device tree nodes
-
-OPAL exposes reserved memory through a top-level reserved-memory node,
-containing subnodes that represent each reserved memory region.
-
-This follows the Linux specification for the /reserved-memory node,
-described in the kernel source tree, in:
-
-  Documentation/devicetree/bindings/reserved-memory/reserved-memory.txt
-
-The top-level /reserved-memory node contains:
-
-  #size-cells = <2>
-  #address-cells = <2>
-   - addresses and sizes are all 64-bits
-
-  ranges;
-   - the empty ranges node indicates no translation of physical
-     addresses in the subnodes.
-
-The sub-nodes under the /reserved-memory node contain:
-
- reg = <address size>
-  - the address and size of the reserved memory region. The address
-    and size values are two cells each, as signified by the top-level
-    #{address,size}-cells
-
- ibm,prd-label = "string"
-  - a string token for use by the prd system. Specific ranges may be
-    used by prd - those will be referenced by this label.
diff --git a/doc/device-tree/vpd.rst b/doc/device-tree/vpd.rst
new file mode 100644
index 0000000..a2c5e63
--- /dev/null
+++ b/doc/device-tree/vpd.rst
@@ -0,0 +1,68 @@
+VPD (Vital Product Data)
+------------------------
+
+VPD provides the information about the FRUs (Field Replaceable Unit) present in
+the system and each vpd node in the device tree represents a FRU. These node and
+their properties are specific to the FSP-based systems, passed to the skiboot in
+the form of FSP-defined HDAT structures. skiboot parses these structures and
+add respective nodes in the device tree.
+
+/vpd			: VPD root node
+<fru-name>@<rsrc-id>	: Node name
+ibm,vpd			: VPD data binary blob
+ccin			: Customer Card Identification Number
+fru-type		: FRU type label (2 bytes ASCII character)
+fru-number		: FRU stocking part number
+ibm,loc-code		: Location code
+part-number		: Part number
+serial-number		: Serial number
+ibm,chip-id		: Processor Id
+size			: DIMM size (applicable for DIMM VPD only)
+ibm,memory-bus-frequency: DIMM frequency (applicable for DIMM VPD only)
+
+The VPD tree in the device tree depicts the hierarchial structure of the
+FRUs having parent-child relationship.
+
+root-node-vpd@a000
+    |-- enclosure@1e00
+    |   |-- air-mover@3a00
+    |   |-- air-mover@3a01
+    |   |-- backplane@800
+    |   |   |-- anchor-card@500
+    |   |   |-- backplane-extender@900
+    |   |   |   |-- serial-connector@2a00
+    |   |   |   |-- usb-connector@2900
+    |   |   |   `-- usb-connector@2901
+    |   |   |-- ethernet-connector@2800
+    |   |   |-- ethernet-connector@2801
+    |   |   |-- ms-dimm@d002
+    |   |   |-- ms-dimm@d003
+    |   |   |-- processor@1000
+    |   |   |-- processor@1001
+    |   |   |-- usb-connector@2902
+    |   |   |-- usb-connector@2903
+    |   |   |-- usb-connector@2904
+    |   |   `-- usb-connector@2905
+    |   |-- dasd-backplane@2400
+    |   |-- dasd-backplane@2401
+    |   |-- power-supply@3103
+    |   `-- service-processor@200
+    |-- enclosure-fault-led@a300
+    |-- enclosure-led@a200
+    |-- root-node-vpd@a001
+    `-- system-vpd@1c00
+
+Example vpd node:
+
+anchor-card@500 {
+	ccin = "52FE";
+	fru-number = "00E2147";
+	description = "System Anchor Card - IBM Power 824";
+	ibm,loc-code = "U78C9.001.WZS007X-P1-C13";
+	serial-number = "YL10113BJ001";
+	ibm,vpd = <0x84cc0052 0x54045649 0x4e494452 0x10414e43 0x484f5220 0x20202020 0x20202020 0x20434501 0x31565a02 0x3031464e 0x7303045 0x32313437 0x504e0730 0x30453231 0x3438534e 0xc594c31 0x30313133 0x424a3030 0x31434304 0x35324645 0x50520881 0x300000 0x48 0x45043030 0x31304354 0x440b400 0x485702 0x14233 0x6000000 0x142 0x34010042 0x370c0000 0x0 0x0 0x4239 0x3c435333 0x22071917 0xd1569c53 0x50973c87 0x71f9c40 0x1d4d3142 0x985e80f1 0x5cb3614d 0x32a902cb 0xd9d714ab 0x164d3322 0xdda4f986 0x5a618f4d 0x340b157c 0x2cac0a94 0x6504603 0x78 0x0>;
+	fru-type = [41 56];
+	part-number = "00E2148";
+	phandle = <0x8d>;
+	linux,phandle = <0x8d>;
+};
diff --git a/doc/device-tree/vpd.txt b/doc/device-tree/vpd.txt
deleted file mode 100644
index a2c5e63..0000000
--- a/doc/device-tree/vpd.txt
+++ /dev/null
@@ -1,68 +0,0 @@
-VPD (Vital Product Data)
-------------------------
-
-VPD provides the information about the FRUs (Field Replaceable Unit) present in
-the system and each vpd node in the device tree represents a FRU. These node and
-their properties are specific to the FSP-based systems, passed to the skiboot in
-the form of FSP-defined HDAT structures. skiboot parses these structures and
-add respective nodes in the device tree.
-
-/vpd			: VPD root node
-<fru-name>@<rsrc-id>	: Node name
-ibm,vpd			: VPD data binary blob
-ccin			: Customer Card Identification Number
-fru-type		: FRU type label (2 bytes ASCII character)
-fru-number		: FRU stocking part number
-ibm,loc-code		: Location code
-part-number		: Part number
-serial-number		: Serial number
-ibm,chip-id		: Processor Id
-size			: DIMM size (applicable for DIMM VPD only)
-ibm,memory-bus-frequency: DIMM frequency (applicable for DIMM VPD only)
-
-The VPD tree in the device tree depicts the hierarchial structure of the
-FRUs having parent-child relationship.
-
-root-node-vpd@a000
-    |-- enclosure@1e00
-    |   |-- air-mover@3a00
-    |   |-- air-mover@3a01
-    |   |-- backplane@800
-    |   |   |-- anchor-card@500
-    |   |   |-- backplane-extender@900
-    |   |   |   |-- serial-connector@2a00
-    |   |   |   |-- usb-connector@2900
-    |   |   |   `-- usb-connector@2901
-    |   |   |-- ethernet-connector@2800
-    |   |   |-- ethernet-connector@2801
-    |   |   |-- ms-dimm@d002
-    |   |   |-- ms-dimm@d003
-    |   |   |-- processor@1000
-    |   |   |-- processor@1001
-    |   |   |-- usb-connector@2902
-    |   |   |-- usb-connector@2903
-    |   |   |-- usb-connector@2904
-    |   |   `-- usb-connector@2905
-    |   |-- dasd-backplane@2400
-    |   |-- dasd-backplane@2401
-    |   |-- power-supply@3103
-    |   `-- service-processor@200
-    |-- enclosure-fault-led@a300
-    |-- enclosure-led@a200
-    |-- root-node-vpd@a001
-    `-- system-vpd@1c00
-
-Example vpd node:
-
-anchor-card@500 {
-	ccin = "52FE";
-	fru-number = "00E2147";
-	description = "System Anchor Card - IBM Power 824";
-	ibm,loc-code = "U78C9.001.WZS007X-P1-C13";
-	serial-number = "YL10113BJ001";
-	ibm,vpd = <0x84cc0052 0x54045649 0x4e494452 0x10414e43 0x484f5220 0x20202020 0x20202020 0x20434501 0x31565a02 0x3031464e 0x7303045 0x32313437 0x504e0730 0x30453231 0x3438534e 0xc594c31 0x30313133 0x424a3030 0x31434304 0x35324645 0x50520881 0x300000 0x48 0x45043030 0x31304354 0x440b400 0x485702 0x14233 0x6000000 0x142 0x34010042 0x370c0000 0x0 0x0 0x4239 0x3c435333 0x22071917 0xd1569c53 0x50973c87 0x71f9c40 0x1d4d3142 0x985e80f1 0x5cb3614d 0x32a902cb 0xd9d714ab 0x164d3322 0xdda4f986 0x5a618f4d 0x340b157c 0x2cac0a94 0x6504603 0x78 0x0>;
-	fru-type = [41 56];
-	part-number = "00E2148";
-	phandle = <0x8d>;
-	linux,phandle = <0x8d>;
-};